import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import { MixedType } from './MixedType';

function FN(value) {
  return +value;
}

export var NumberType = /*#__PURE__*/function (_MixedType) {
  _inheritsLoose(NumberType, _MixedType);

  function NumberType(errorMessage) {
    var _this;

    _this = _MixedType.call(this, 'number') || this;

    _MixedType.prototype.pushRule.call(_assertThisInitialized(_this), function (value) {
      return /^-?(?:\d+|\d{1,3}(?:,\d{3})+)(?:\.\d+)?$/.test(value + '');
    }, errorMessage || 'Please enter a valid number');

    return _this;
  }

  var _proto = NumberType.prototype;

  _proto.isInteger = function isInteger(errorMessage) {
    _MixedType.prototype.pushRule.call(this, function (value) {
      return /^-?\d+$/.test(value + '');
    }, errorMessage);

    return this;
  };

  _proto.pattern = function pattern(regexp, errorMessage) {
    _MixedType.prototype.pushRule.call(this, function (value) {
      return regexp.test(value + '');
    }, errorMessage);

    return this;
  };

  _proto.isOneOf = function isOneOf(numLst, errorMessage) {
    _MixedType.prototype.pushRule.call(this, function (value) {
      return numLst.includes(FN(value));
    }, errorMessage);

    return this;
  };

  _proto.range = function range(min, max, errorMessage) {
    _MixedType.prototype.pushRule.call(this, function (value) {
      return FN(value) >= min && FN(value) <= max;
    }, errorMessage);

    return this;
  };

  _proto.min = function min(_min, errorMessage) {
    _MixedType.prototype.pushRule.call(this, function (value) {
      return FN(value) >= _min;
    }, errorMessage);

    return this;
  };

  _proto.max = function max(_max, errorMessage) {
    _MixedType.prototype.pushRule.call(this, function (value) {
      return FN(value) <= _max;
    }, errorMessage);

    return this;
  };

  return NumberType;
}(MixedType);
export default function getNumberType(errorMessage) {
  return new NumberType(errorMessage);
}