import { MixedType } from './MixedType';
import { PlainObject, SchemaDeclaration, CheckResult } from './types';
export declare class ObjectType<DataType = any, ErrorMsgType = string> extends MixedType<PlainObject, DataType, ErrorMsgType> {
    objectTypeSchemaSpec: SchemaDeclaration<DataType, ErrorMsgType>;
    constructor(errorMessage?: ErrorMsgType);
    check(value?: PlainObject, data?: DataType): CheckResult<string | ErrorMsgType>;
    checkAsync(value?: PlainObject, data?: DataType): Promise<CheckResult<string | ErrorMsgType>>;
    /**
     * @example
     * ObjectType().shape({
     *  name: StringType(),
     *  age: NumberType()
     * })
     */
    shape(fields: SchemaDeclaration<DataType, ErrorMsgType>): this;
}
export default function getObjectType<DataType = any, ErrorMsgType = string>(errorMessage?: ErrorMsgType): ObjectType<DataType, ErrorMsgType>;
