import { MixedType } from './MixedType';
import { CheckType } from './types';
export declare class ArrayType<DataType = any, ErrorMsgType = string> extends MixedType<any[], DataType, ErrorMsgType> {
    constructor(errorMessage?: ErrorMsgType);
    rangeLength(minLength: number, maxLength: number, errorMessage?: ErrorMsgType): this;
    minLength(minLength: number, errorMessage?: ErrorMsgType): this;
    maxLength(maxLength: number, errorMessage?: ErrorMsgType): this;
    unrepeatable(errorMessage?: ErrorMsgType): this;
    /**
     * @example
     * ArrayType().of(StringType().isOneOf(['数码','体育','游戏','旅途','其他'],'Can only be the value of a predefined option')
     */
    of(type: CheckType<any[], DataType, ErrorMsgType>, errorMessage?: ErrorMsgType): this;
}
export default function getArrayType<DataType = any, ErrorMsgType = string>(errorMessage?: ErrorMsgType): ArrayType<DataType, ErrorMsgType>;
