"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = getDateType;
exports.DateType = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _MixedType2 = require("./MixedType");

var DateType = /*#__PURE__*/function (_MixedType) {
  (0, _inheritsLoose2["default"])(DateType, _MixedType);

  function DateType(errorMessage) {
    var _this;

    _this = _MixedType.call(this, 'date') || this;

    _MixedType.prototype.pushRule.call((0, _assertThisInitialized2["default"])(_this), function (value) {
      return !/Invalid|NaN/.test(new Date(value).toString());
    }, errorMessage || 'Please enter a valid date');

    return _this;
  }

  var _proto = DateType.prototype;

  _proto.range = function range(min, max, errorMessage) {
    _MixedType.prototype.pushRule.call(this, function (value) {
      return new Date(value) >= new Date(min) && new Date(value) <= new Date(max);
    }, errorMessage);

    return this;
  };

  _proto.min = function min(_min, errorMessage) {
    _MixedType.prototype.pushRule.call(this, function (value) {
      return new Date(value) >= new Date(_min);
    }, errorMessage);

    return this;
  };

  _proto.max = function max(_max, errorMessage) {
    _MixedType.prototype.pushRule.call(this, function (value) {
      return new Date(value) <= new Date(_max);
    }, errorMessage);

    return this;
  };

  return DateType;
}(_MixedType2.MixedType);

exports.DateType = DateType;

function getDateType(errorMessage) {
  return new DateType(errorMessage);
}