"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = getNumberType;
exports.NumberType = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _MixedType2 = require("./MixedType");

function FN(value) {
  return +value;
}

var NumberType = /*#__PURE__*/function (_MixedType) {
  (0, _inheritsLoose2["default"])(NumberType, _MixedType);

  function NumberType(errorMessage) {
    var _this;

    _this = _MixedType.call(this, 'number') || this;

    _MixedType.prototype.pushRule.call((0, _assertThisInitialized2["default"])(_this), function (value) {
      return /^-?(?:\d+|\d{1,3}(?:,\d{3})+)(?:\.\d+)?$/.test(value + '');
    }, errorMessage || 'Please enter a valid number');

    return _this;
  }

  var _proto = NumberType.prototype;

  _proto.isInteger = function isInteger(errorMessage) {
    _MixedType.prototype.pushRule.call(this, function (value) {
      return /^-?\d+$/.test(value + '');
    }, errorMessage);

    return this;
  };

  _proto.pattern = function pattern(regexp, errorMessage) {
    _MixedType.prototype.pushRule.call(this, function (value) {
      return regexp.test(value + '');
    }, errorMessage);

    return this;
  };

  _proto.isOneOf = function isOneOf(numLst, errorMessage) {
    _MixedType.prototype.pushRule.call(this, function (value) {
      return numLst.includes(FN(value));
    }, errorMessage);

    return this;
  };

  _proto.range = function range(min, max, errorMessage) {
    _MixedType.prototype.pushRule.call(this, function (value) {
      return FN(value) >= min && FN(value) <= max;
    }, errorMessage);

    return this;
  };

  _proto.min = function min(_min, errorMessage) {
    _MixedType.prototype.pushRule.call(this, function (value) {
      return FN(value) >= _min;
    }, errorMessage);

    return this;
  };

  _proto.max = function max(_max, errorMessage) {
    _MixedType.prototype.pushRule.call(this, function (value) {
      return FN(value) <= _max;
    }, errorMessage);

    return this;
  };

  return NumberType;
}(_MixedType2.MixedType);

exports.NumberType = NumberType;

function getNumberType(errorMessage) {
  return new NumberType(errorMessage);
}